<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>conqueue: mutils::conqueue&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">conqueue
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><b>mutils</b></li><li class="navelem"><a class="el" href="classmutils_1_1conqueue.html">conqueue</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classmutils_1_1conqueue-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">mutils::conqueue&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="conqueue_8h_source.html">conqueue.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a8f0b24fc2bf5a4e84db449a9c4fc65b2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmutils_1_1conqueue.html#a8f0b24fc2bf5a4e84db449a9c4fc65b2">~conqueue</a> ()</td></tr>
<tr class="separator:a8f0b24fc2bf5a4e84db449a9c4fc65b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aebad37af104f9b7bafbd02325795ee81"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmutils_1_1conqueue.html#aebad37af104f9b7bafbd02325795ee81">enqueue</a> (T &amp;&amp;el)</td></tr>
<tr class="separator:aebad37af104f9b7bafbd02325795ee81"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae5e6b297131a997b8e6a37b1ae9b6f52"><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmutils_1_1conqueue.html#ae5e6b297131a997b8e6a37b1ae9b6f52">dequeue</a> ()</td></tr>
<tr class="separator:ae5e6b297131a997b8e6a37b1ae9b6f52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a389275c51e7eb3f367c2ee8ac70a2615"><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmutils_1_1conqueue.html#a389275c51e7eb3f367c2ee8ac70a2615">dequeueOrBlock</a> ()</td></tr>
<tr class="separator:a389275c51e7eb3f367c2ee8ac70a2615"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f77547ec1b71152b6b5657259b704fc"><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmutils_1_1conqueue.html#a1f77547ec1b71152b6b5657259b704fc">dequeueOrBlockFor</a> (std::chrono::system_clock::duration)</td></tr>
<tr class="separator:a1f77547ec1b71152b6b5657259b704fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename T&gt;<br />
class mutils::conqueue&lt; T &gt;</h3>

<p>This class represents a concurrent queue. All the methods are thread safe which means that they can be called from different threads without any data inconsitency. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a8f0b24fc2bf5a4e84db449a9c4fc65b2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8f0b24fc2bf5a4e84db449a9c4fc65b2">&#9670;&nbsp;</a></span>~conqueue()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmutils_1_1conqueue.html">mutils::conqueue</a>&lt; T &gt;::~<a class="el" href="classmutils_1_1conqueue.html">conqueue</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Default destructor. When it is called the internal container is cleaned. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ae5e6b297131a997b8e6a37b1ae9b6f52"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae5e6b297131a997b8e6a37b1ae9b6f52">&#9670;&nbsp;</a></span>dequeue()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classmutils_1_1conqueue.html">mutils::conqueue</a>&lt; T &gt;::dequeue </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>It dequeues the first element in the queue. When the method has a return value, that value has been removed from the queue. This method is thread safe.</p>
<dl class="section return"><dt>Returns</dt><dd>The first elment of the queue. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">std::runtime_error</td><td>when the queue is empty. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a389275c51e7eb3f367c2ee8ac70a2615"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a389275c51e7eb3f367c2ee8ac70a2615">&#9670;&nbsp;</a></span>dequeueOrBlock()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classmutils_1_1conqueue.html">mutils::conqueue</a>&lt; T &gt;::dequeueOrBlock </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>It dequeues the first element of the queue. In the case the queue is empty, the the calling thread is blocked until the queue has an element for it. When the method has a return value, that value has been removed from the queue. This method is thread safe.</p>
<dl class="section return"><dt>Returns</dt><dd>The first element of the queue. </dd></dl>

</div>
</div>
<a id="a1f77547ec1b71152b6b5657259b704fc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1f77547ec1b71152b6b5657259b704fc">&#9670;&nbsp;</a></span>dequeueOrBlockFor()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classmutils_1_1conqueue.html">mutils::conqueue</a>&lt; T &gt;::dequeueOrBlockFor </td>
          <td>(</td>
          <td class="paramtype">std::chrono::system_clock::duration&#160;</td>
          <td class="paramname"><em>duration</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>It dequeues the first element of the queue. In the case of an empty queue, the caller blocks for the given duration. It becomes unblocked when at least one element is present in the queue or the time has expired. When the method has a return value, that value has been removed from the queue. This emthod is thread safe.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">duration</td><td>The time that the caller should wait for an element in the queue.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The first eleemnt of the queue, if there are any. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">std::runtime_error</td><td>when the time has expired and the queue is empty. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aebad37af104f9b7bafbd02325795ee81"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aebad37af104f9b7bafbd02325795ee81">&#9670;&nbsp;</a></span>enqueue()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classmutils_1_1conqueue.html">mutils::conqueue</a>&lt; T &gt;::enqueue </td>
          <td>(</td>
          <td class="paramtype">T &amp;&amp;&#160;</td>
          <td class="paramname"><em>el</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>It enqueues an element to the end of the queue. This method is thread safe.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">el</td><td>The element that should be queued. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="conqueue_8h_source.html">conqueue.h</a></li>
<li>src/<a class="el" href="conqueue_8hpp_source.html">conqueue.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
